LeetCode-88

题目:

88. 合并两个有序数组

思路:

最开始想到的就是使用一个中间数组来存放合并后的数据,对两个数组使用双指针进行遍历,将两个数组中较小的放入中间数据。

看了题解,发现可以逆序进行遍历,因为nums1中后面几位是0, 可以进行覆盖,选择两个数组中较大值放入nums1后面,节省了中间数组的空间。

代码:

java 复制代码
// 顺序双指针
public void merge(int[] nums1, int m, int[] nums2, int n) {
        int[] result = new int[m+n];
        int i = 0;
        int j = 0;
        for(int x = 0; x <= m+n-1; x ++){
            // 添加nums1中的元素的条件: 1)nums1中的数据没有遍历完;
            // 2)并且nums2中的数据已经遍历完了 或者 nums1中的数据<nums2中的数据
            if(i <= m-1 && (j >= n || nums1[i] <= nums2[j])){
                result[x] = nums1[i];
                i++;
            }
            else{
                result[x] = nums2[j];
                j++;
            }
        }
        // 将中间数组的结果给nums1数组
        int index = 0;
        for (int i1 : result) {
            nums1[index++] = i1;
        }
    }

// 逆序双指针
public void merge(int[] nums1, int m, int[] nums2, int n) {
        // int[] result = new int[m+n];
        int i = m-1;
        int j = n-1;
        for(int x = m+n-1; x >= 0; x--){
            // 与顺序双指针类似
            if(i >= 0 && (j < 0 || nums1[i] > nums2[j])){
                nums1[x] = nums1[i];
                i--;
            }
            else{
                nums1[x] = nums2[j];
                j--;
            }
        }

    }

Tips:

JAVA对数组进行排序:Arrays.sort(nums1)

Collections.sort(List<>)是对List进行排序

题目

26. 删除有序数组中的重复项

思路

1)使用一个List来记录数组中的元素情况(类似一个set 使用.contains()进行处理),然后将这个list中的数据覆盖到原数组中;

2)使用双指针,slow指针指向下一个不重复元素所放下标,fast指针指向不重复元素的下标。如果munsfast!=numsfast-1 表明当前下标的元素就是不重复的

代码

java 复制代码
public int removeDuplicates(int[] nums) {
        // 统计数组中的元素
        List<Integer> a = new ArrayList<>();
        for (int i : nums) {
            if(!a.contains(i)){
                a.add(i);
            }
        }
        int j = 0;
        int len = a.size();
        for(int i=0; j < len; i++){
            nums[i] = a.get(j++);
        }
        return len;

    }

// 双指针
public int removeDuplicates(int[] nums) {
        if(nums == null){
            return 0;
        }
        if(nums.length == 1){
            return 1;
        }
        int fast = 1;
        int slow = 1;
        for(; fast < nums.length; fast ++){
            if(nums[fast] != nums[fast-1]){
                nums[slow] = nums[fast];
                slow ++;
            }
        }
        return slow;

    }
相关推荐
2601_949950632 小时前
练题簿在线免费刷题 从资料整理到考前自测
面试·职场和发展·pdf·word·刷题
hetao17338373 小时前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6264 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan4 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356385 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah5 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO95 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician5 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
lsc_blog5 小时前
远程和居家办公的经历,技术简历上怎么摆
面试·职场和发展·重构·pdf·求职招聘
垆边人似月.6 小时前
VLAN 资源池(100~200 分档)
数据结构·算法